#include "stdafx.h"
#include "Conversion.h"

CReplyBase*	CreateReply(LPCTSTR szQueryID)
{
	CReplyBase* pReplyBase = NULL;
	if( lstrcmpi( szQueryID, REQ_AGREEMENT_SHOWN ) == 0 )
	{
		pReplyBase = new CReplyAgreementShown;
	}
	else if( lstrcmpi( szQueryID, REQ_AGREEMENT_ISSHOW ) == 0 )
	{
		pReplyBase = new CReplyAgreementIsShow;
	}
	else if( lstrcmpi( szQueryID, REQ_AGREEMENT_URL ) == 0 )
	{
		pReplyBase = new CReplyAgreementURL;
	}
	else if( lstrcmpi( szQueryID, REQ_GUID ) == 0 )
	{
		pReplyBase = new CReplyReqGUID;
	}
	else if( lstrcmpi( szQueryID, REQ_ISINSTALLED ) == 0 )
	{
		pReplyBase = new CReplyIsInstalled;
	}
	else if( lstrcmpi( szQueryID, REQ_UNINSTALLER_URL ) == 0 )
	{
		pReplyBase = new CReplyUninstallerURL;
	}
	else if( lstrcmpi( szQueryID, REQ_VERSION_LOCAL ) == 0 )
	{
		pReplyBase = new CReplyVersionLocal;
	}
	else if( lstrcmpi( szQueryID, REQ_VERSION_RECENT ) == 0 )
	{
		pReplyBase = new CReplyVersionRecent;
	}
	else if( lstrcmpi( szQueryID, REQ_VERSION_ISCHANGED ) == 0 )
	{
		pReplyBase = new CReplyIsChanged;
	}
	else if( lstrcmpi( szQueryID, REQ_UPGRADER_RUN ) == 0 )
	{
		pReplyBase = new CReplyUpgraderRun;
	}
	else if( lstrcmpi( szQueryID, REQ_UPGRADER_STATUS ) == 0 )
	{
		pReplyBase = new CReplyUpgraderStatus;
	}
	else if( lstrcmpi( szQueryID, REQ_INSTALL_ERROR ) == 0 )
	{
		pReplyBase = new CReplyInstallError;
	}
	else if( lstrcmpi( szQueryID, REQ_UNINSTALL_ERROR ) == 0 )
	{
		pReplyBase = new CReplyUninstallError;
	}

	if ( pReplyBase )
	{
		pReplyBase->SetQueryID(szQueryID);
	}

	return pReplyBase;
}

int __cdecl Request (const char* query, char* response, int response_length)
{
	CConversion cv;
	int nBufLen = response_length + 1;
	LPTSTR	szResult = new TCHAR[nBufLen];
	if ( szResult == NULL )
	{
		ATLASSERT(FALSE);
		return -1;
	}
	ZeroMemory(szResult, nBufLen);
	CReplyBase* pReply = NULL;

	while(TRUE)
	{
		TCHAR szID[MAX_PATH] = { 0 };

		if ( GetQueryIDnValue(query, szID, MAX_PATH, NULL, 0) == FALSE )
		{
			//ID ° ϸ  ..
			ATLASSERT(FALSE);
			break;
		}

		/*#ifdef _DEBUG
				OutputDebugString(_T("============================================================="));
				OutputDebugString(_T("AgentDLL query start.."));
				OutputDebugString(cv.UTF8_TO_TCHAR(query));
				OutputDebugString(_T("AgentDLL query end"));
		#endif/**/

		CReplyBase* pReply = CreateReply(szID);
		if ( pReply == NULL )
		{
			ATLASSERT(FALSE);
			CReplyBase::MakeBoolResponseXMLEx(szID, FALSE, szResult, MAX_PATH, NQUERY_ERROR_WRONGQUERY,
											  GetErrorString(ERROR_UNKNOWN_ERROR));
			break;
		}

		if ( pReply->DoRequest(query, szResult, response_length) == FALSE )
		{
			ATLASSERT(FALSE);
			CReplyBase::MakeBoolResponseXMLEx(szID, FALSE, szResult, nBufLen, NQUERY_ERROR_WRONGQUERY,
											  GetErrorString(ERROR_UNKNOWN_ERROR));
		}
		/*#ifdef _DEBUG
				else
				{
					OutputDebugString(_T("============================================================="));
					OutputDebugString(_T("AgentDLL result start.."));
					OutputDebugString(szResult);
					OutputDebugString(_T("AgentDLL result end.."));
				}
		#endif/**/

		break;
	}

	int nResult;
	if ( lstrlen(szResult) > 0 )
	{
		StringCchCopyA(response, response_length, (LPSTR)cv.TCHAR_TO_UTF8(szResult));
		nResult = strlen(response);
	}
	else
	{
		nResult = -1;
	}

	if ( pReply != NULL )
	{
		delete pReply;
	}
	delete []szResult;

	return nResult;
}